package jp.co.techw.io.android_modbus_sample;

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

import android.app.*;
import android.content.Intent;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.View;
import android.widget.AdapterView;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.ToggleButton;

public class PortSampleActivity extends Activity implements OnCheckedChangeListener {
	private Spinner menuSpinner;
	
	private ToggleButton[] od;
	private ToggleButton[] oe;
	private ToggleButton[] of;
	private ToggleButton[] ia;
	private ToggleButton[] ib;
	private ToggleButton[] ic;
	
	private ModbusClient modbusClient = null;
	private Timer timer;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		//メインスレッドからの通信を許可する
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitAll().build());
		
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.port_sample);
		menuSpinner = (Spinner) findViewById(R.id.MenuSpinner);
		menuSpinner.setSelection(1);
		menuSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			//スピナーのアイテムが選択された時の動作
			@Override
			public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
				// 選択されたアイテムのテキストを取得
				Spinner spinner = (Spinner) parent;
				String str = spinner.getSelectedItem().toString();
				//このアクティビティを終了しメイン画面へ遷移
				if (str.equals("Main")) {
					if(timer != null) timer.cancel();
					Intent intent = new Intent(getApplicationContext(), MainActivity.class);
					startActivity(intent);
					finish();
				} else if (str.equals("Port Sample")) {
				//このアクティビティを終了しAnalog IO Sample画面へ遷移
				} else if (str.equals("Analog IO Sample")) {
					if(timer != null) timer.cancel();
					Intent intent = new Intent(getApplicationContext(), AnalogIOSampleActivity.class);
					startActivity(intent);
					finish();
				//このアクティビティを終了しPWM Sample画面へ遷移
				} else if (str.equals("PWM Sample")) {
					if(timer != null) timer.cancel();
					Intent intent = new Intent(getApplicationContext(), PWMSampleActivity.class);
					startActivity(intent);
					finish();
				//このアクティビティを終了しPulse Count Sample画面へ遷移
				} else if (str.equals("Pulse Count Sample")) {
					if(timer != null) timer.cancel();
					Intent intent = new Intent(getApplicationContext(), PulseCountSampleActivity.class);
					startActivity(intent);
					finish();
				}
			}

			// 何も選択されなかった時の動作
			@Override
			public void onNothingSelected(AdapterView<?> parent) {
			}
		});

		//画面のボタンと紐付け
		od = new ToggleButton[8];
		od[0] = (ToggleButton) findViewById(R.id.od0);
		od[1] = (ToggleButton) findViewById(R.id.od1);
		od[2] = (ToggleButton) findViewById(R.id.od2);
		od[3] = (ToggleButton) findViewById(R.id.od3);
		od[4] = (ToggleButton) findViewById(R.id.od4);
		od[5] = (ToggleButton) findViewById(R.id.od5);
		od[6] = (ToggleButton) findViewById(R.id.od6);
		od[7] = (ToggleButton) findViewById(R.id.od7);
		for (int i = 0; i < 8; i++) {
			od[i].setOnCheckedChangeListener(this);
		}

		oe = new ToggleButton[8];
		oe[0] = (ToggleButton) findViewById(R.id.oe0);
		oe[1] = (ToggleButton) findViewById(R.id.oe1);
		oe[2] = (ToggleButton) findViewById(R.id.oe2);
		oe[3] = (ToggleButton) findViewById(R.id.oe3);
		oe[4] = (ToggleButton) findViewById(R.id.oe4);
		oe[5] = (ToggleButton) findViewById(R.id.oe5);
		oe[6] = (ToggleButton) findViewById(R.id.oe6);
		oe[7] = (ToggleButton) findViewById(R.id.oe7);
		for (int i = 0; i < 8; i++) {
			oe[i].setOnCheckedChangeListener(this);
		}

		of = new ToggleButton[3];
		of[0] = (ToggleButton) findViewById(R.id.of0);
		of[1] = (ToggleButton) findViewById(R.id.of1);
		of[2] = (ToggleButton) findViewById(R.id.of2);
		for (int i = 0; i < 3; i++) {
			of[i].setOnCheckedChangeListener(this);
		}

		ia = new ToggleButton[8];
		ia[0] = (ToggleButton) findViewById(R.id.ia0);
		ia[1] = (ToggleButton) findViewById(R.id.ia1);
		ia[2] = (ToggleButton) findViewById(R.id.ia2);
		ia[3] = (ToggleButton) findViewById(R.id.ia3);
		ia[4] = (ToggleButton) findViewById(R.id.ia4);
		ia[5] = (ToggleButton) findViewById(R.id.ia5);
		ia[6] = (ToggleButton) findViewById(R.id.ia6);
		ia[7] = (ToggleButton) findViewById(R.id.ia7);
		for (int i = 0; i < 8; i++) {
			ia[i].setClickable(false);
		}

		ib = new ToggleButton[8];
		ib[0] = (ToggleButton) findViewById(R.id.ib0);
		ib[1] = (ToggleButton) findViewById(R.id.ib1);
		ib[2] = (ToggleButton) findViewById(R.id.ib2);
		ib[3] = (ToggleButton) findViewById(R.id.ib3);
		ib[4] = (ToggleButton) findViewById(R.id.ib4);
		ib[5] = (ToggleButton) findViewById(R.id.ib5);
		ib[6] = (ToggleButton) findViewById(R.id.ib6);
		ib[7] = (ToggleButton) findViewById(R.id.ib7);
		for (int i = 0; i < 8; i++) {
			ib[i].setClickable(false);
		}

		ic = new ToggleButton[6];
		ic[0] = (ToggleButton) findViewById(R.id.ic0);
		ic[1] = (ToggleButton) findViewById(R.id.ic1);
		ic[2] = (ToggleButton) findViewById(R.id.ic2);
		ic[3] = (ToggleButton) findViewById(R.id.ic3);
		ic[4] = (ToggleButton) findViewById(R.id.ic4);
		ic[5] = (ToggleButton) findViewById(R.id.ic5);
		for (int i = 0; i < 6; i++) {
			ic[i].setClickable(false);
		}

		//メイン画面で接続した機器へのソケットを取得
		modbusClient = MainActivity.getModbusClient();
		if (modbusClient != null) { //接続されている場合初期化
			initialize();
		} else {
			Toast.makeText(PortSampleActivity.this, "未接続です", Toast.LENGTH_LONG).show();
		}
	}

	//切断
	private void closeModbus() {
		modbusClient = null;
		MainActivity.closeModbus();
		timer.cancel();
	}

	//初期化
	public void initialize() {
		short[] shortOutput = new short[3];
		int ret;
		try {
			//すべての出力を停止
			shortOutput[0] &= 0x0000;
			shortOutput[1] &= 0x0000;
			shortOutput[2] &= 0x0000;
			shortOutput[0] |= 0xff00;
			shortOutput[1] |= 0xff00;
			shortOutput[2] |= 0xff00;
			ret = modbusClient.writeMultipleRegisters(40101, shortOutput, 3, 0, 0);
			if (ret != 0) {
				Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
				closeModbus();
				return;
			}
			
			//タイマーを100ミリ秒に設定し、入力値の更新を行う
			timer = new Timer();
			timer.schedule(new TimerTask() {
				@Override
				public void run() {
					runOnUiThread(new Runnable() {
						@Override
						public void run() {
							checkInput();
						}
					});
				}
			}, 0, 100);

		} catch (IOException ex) {
			Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
			closeModbus();
		}
	}

	//ボタンのチェック状態が変わった場合の処理
	@Override
	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		if (modbusClient == null)
			return;
		int i;
		short bit;
		short[] shortOutput = new short[3];

		for (i = 0, bit = 0x01; i < 8; bit <<= 1, i++) {
			if (od[i].isChecked())
				shortOutput[0] |= bit;
		}
		for (i = 0, bit = 0x01; i < 8; bit <<= 1, i++) {
			if (oe[i].isChecked())
				shortOutput[1] |= bit;
		}
		for (i = 0, bit = 0x01; i < 3; bit <<= 1, i++) {
			if (of[i].isChecked())
				shortOutput[2] |= bit;
		}
		shortOutput[0] |= 0xff00;
		shortOutput[1] |= 0xff00;
		shortOutput[2] |= 0xff00;

		try {
			int ret;
			ret = modbusClient.writeMultipleRegisters(40101, shortOutput, 3, 0, 0);
			if (ret != 0) {
				Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
				closeModbus();
				return;
			}
		} catch (IOException ex) {
			Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
			closeModbus();
		}

	}

	//タイマーにより100ミリ秒ごとに入力ポートの状態を更新
	private void checkInput() {
		int ret, i;
		short bit;
		short[] shortInput = new short[3];

		if (modbusClient == null)
			return;
		try {
			ret = modbusClient.readInputRegisters(30101, shortInput, 3, 0, 0);
			shortInput[0] &= 0x00FF;
			shortInput[1] &= 0x00FF;
			shortInput[2] &= 0x00FF;
		

			for (i = 0, bit = 0x01; i < 8; bit <<= 1, i++) {
				if ((shortInput[0] & bit) != 0){
					ia[i].setChecked(true);
				}else{
					ia[i].setChecked(false);
				}
			}
			for (i = 0, bit = 0x01; i < 8; bit <<= 1, i++) {
				if ((shortInput[1] & bit) != 0){
					ib[i].setChecked(true);
				}else{
					ib[i].setChecked(false);
				}
			}
			for (i = 0, bit = 0x01; i < 6; bit <<= 1, i++) {
				if ((shortInput[2] & bit) != 0){
					ic[i].setChecked(true);
				}else{
					ic[i].setChecked(false);
				}
			}
			if (ret != 0) {
				Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
				closeModbus();
				return;
			}
		} catch (IOException ex) {
			Toast.makeText(PortSampleActivity.this, "エラーが発生しました", Toast.LENGTH_LONG).show();
			closeModbus();
		}
	}

}
